#!/bin/sh
# PCP QA Test No. 1338
# Test that context labels can be created, deleted and rewritten
# by pmlogrewrite(1)
#
# Copyright (c) 2018 Red Hat.  All Rights Reserved.
#

seq=`basename $0`
echo "QA output created by $seq"

# get standard environment, filters and checks
. ./common.product
. ./common.filter
. ./common.check

_cleanup()
{
    cd $here
    $sudo rm -rf $tmp $tmp.*
}

status=1	# failure is the default!
trap "_cleanup; exit \$status" 0 1 2 3 15

_filter()
{
    tmpx=`echo $tmp`
    sed -e 's/^Archive:.* Host:/ARCHIVE: Host:/' \
	-e "s|$tmpx|TMP|g" \
	-e 's|PID for pmlogger: [0-9]*|PID for pmlogger: PID|'
}

# real QA test starts here
DIR=archives

# First, run pmlogrewrite against the archive, deleting the context labels
CONFIG=$tmp.config
cat > $CONFIG << EOF
LABEL CONTEXT { } # does nothing
LABEL CONTEXT { delete } # delete all context labels
EOF
echo contents of $CONFIG >> $seq_full
echo ........................ >> $seq_full
cat $CONFIG >> $seq_full
echo ........................ >> $seq_full
IN=$DIR/20180416.10.00
OUT=$tmp.pmlogrewrite
rm -f $OUT.*
echo "Running pmlogrewrite -c $CONFIG $IN $OUT" | _filter | tee -a $seq_full
pmlogrewrite -c $CONFIG $IN $OUT 2>&1 >> $seq_full
[ $? -eq 0 ] || echo "Error running pmlogrewrite -c $CONFIG $IN $OUT -- see $seq.full"

# Now run pmdumplog against the original and rewritten archives.
DUMP1=$tmp.original.txt
echo "Running pmdumplog -zhide $IN" | _filter | tee -a $seq_full
pmdumplog -zhide $IN 2>&1 > $DUMP1

DUMP2=$tmp.rewritten.txt
IN=$OUT
echo "Running pmdumplog -iteh $IN" | _filter | tee -a $seq_full
pmdumplog -zhide $IN 2>&1 > $DUMP2

# Make sure the context labels have been deleted
echo "Running diff $DUMP1 $DUMP2" | _filter | tee -a $seq_full
diff $DUMP1 $DUMP2 2>&1 | _filter | tee -a $seq_full

# Test creating and rewriting context labels
cat > $CONFIG << EOF
LABEL CONTEXT "domainname" { LABEL -> "new_domainname" }
LABEL CONTEXT * "brolley-t530" { VALUE -> "retired-t530" }
LABEL CONTEXT { NEW "new_context_label" "new_context_value" }
LABEL CONTEXT { NEW "new_context_number" -123.456e+789 }
LABEL CONTEXT { NEW "new_context_true" true }
LABEL CONTEXT { NEW "new_context_false" false }
LABEL CONTEXT { NEW "new_context_null" null }
EOF
echo contents of $CONFIG >> $seq_full
echo ........................ >> $seq_full
cat $CONFIG >> $seq_full
echo ........................ >> $seq_full
IN=$DIR/20180416.10.00
OUT=$tmp.pmlogrewrite
rm -f $OUT.*
echo "Running pmlogrewrite -c $CONFIG $IN $OUT" | _filter | tee -a $seq_full
pmlogrewrite -c $CONFIG $IN $OUT 2>&1 >> $seq_full
[ $? -eq 0 ] || echo "Error running pmlogrewrite -c $CONFIG $IN $OUT -- see $seq.full"

# Now run pmdumplog against the original and rewritten archives.
DUMP1=$tmp.original.txt
echo "Running pmdumplog -zhide $IN" | _filter | tee -a $seq_full
pmdumplog -zhide $IN 2>&1 > $DUMP1

DUMP2=$tmp.rewritten.txt
IN=$OUT
echo "Running pmdumplog -iteh $IN" | _filter | tee -a $seq_full
pmdumplog -zhide $IN 2>&1 > $DUMP2

# Make sure the context labels have been deleted
echo "Running diff $DUMP1 $DUMP2" | _filter | tee -a $seq_full
diff $DUMP1 $DUMP2 2>&1 | _filter | tee -a $seq_full

# success, all done
status=0
exit
